-- GTA2 Block info:
-- Revision: v0.1, 16 apr 2018 by DenLover

-- Rotation:
--       N 180
-- W 270 + E 90
--       S 0
ROT_WEST = 270
ROT_EAST = 90
ROT_NORT = 180
ROT_SOUTH = 0

-- Limits:
MAX_BLOCKS = 70 -- n > 70? Crash game
MAX_MAP_X = 256
MAX_MAP_Y = 256
MAX_MAP_Z = 8

-- Block and explosive face type:
FACE_LEFT = 1
FACE_RIGHT = 2
FACE_TOP = 3
FACE_BOTTOM = 4
FACE_UNGROUND = 5 -- (not used in basic arguments)
FACE_GROUND = 6 -- (not used in basic arguments)

-- Drop type:
BLOCK_DONT_DROP = 0
BLOCK_DO_DROP = 1

-- Block flags:
BLOCK_FLAG_AIR = 0
BLOCK_FLAG_ROAD = 1
BLOCK_FLAG_PAVEMENT = 2
BLOCK_FLAG_FIEALD = 3
BLOCK_FLAG_WALL = 4 
BLOCK_FLAG_BULLET = 8 
BLOCK_FLAG_FLAT = 16 
BLOCK_FLAG_FLIP = 32 
BLOCK_FLAG_ROT_0 = 0
BLOCK_FLAG_ROT_90 = 64
BLOCK_FLAG_ROT_180 = 128
BLOCK_FLAG_ROT_270 = 192

-- Slope types:
SLOPE_TYPE_NONE = 0 -- slope = n * 4
SLOPE_TYPE_1 = 4 
SLOPE_TYPE_2 = 8
SLOPE_TYPE_3 = 12
SLOPE_TYPE_4 = 16
SLOPE_TYPE_5 = 20
SLOPE_TYPE_6 = 24
SLOPE_TYPE_7 = 28
SLOPE_TYPE_8 = 32
SLOPE_TYPE_9 = 36
SLOPE_TYPE_10 = 40
SLOPE_TYPE_11 = 44
SLOPE_TYPE_12 = 48
SLOPE_TYPE_13 = 52
SLOPE_TYPE_14 = 56
SLOPE_TYPE_15 = 60
SLOPE_TYPE_16 = 64
SLOPE_TYPE_17 = 68
SLOPE_TYPE_18 = 72
SLOPE_TYPE_19 = 76
SLOPE_TYPE_20 = 80
SLOPE_TYPE_21 = 84
SLOPE_TYPE_22 = 88
SLOPE_TYPE_23 = 92
SLOPE_TYPE_24 = 88
SLOPE_TYPE_25 = 92
SLOPE_TYPE_26 = 96
SLOPE_TYPE_27 = 100
SLOPE_TYPE_28 = 104
SLOPE_TYPE_29 = 108
SLOPE_TYPE_30 = 112
SLOPE_TYPE_31 = 116
SLOPE_TYPE_32 = 120
SLOPE_TYPE_33 = 124
SLOPE_TYPE_34 = 128
SLOPE_TYPE_35 = 132
SLOPE_TYPE_36 = 136
SLOPE_TYPE_37 = 140
SLOPE_TYPE_38 = 144
SLOPE_TYPE_39 = 152
SLOPE_TYPE_40 = 160
SLOPE_TYPE_41 = 164
SLOPE_TYPE_42 = 168
SLOPE_TYPE_43 = 172
SLOPE_TYPE_44 = 176
SLOPE_TYPE_45 = 180
SLOPE_TYPE_46 = 184
SLOPE_TYPE_47 = 188
SLOPE_TYPE_48 = 192
SLOPE_TYPE_49 = 196
SLOPE_TYPE_50 = 200
SLOPE_TYPE_51 = 204
SLOPE_TYPE_52 = 208
SLOPE_TYPE_53 = 212
SLOPE_TYPE_54 = 216
SLOPE_TYPE_55 = 220
SLOPE_TYPE_56 = 224
SLOPE_TYPE_57 = 228
SLOPE_TYPE_58 = 232
SLOPE_TYPE_59 = 236
SLOPE_TYPE_60 = 240
SLOPE_TYPE_61 = 244
SLOPE_TYPE_62 = 248
SLOPE_TYPE_63 = 252