-- Light methods
-- Since: v0.4.1
local Light = {}

--[[
function Light.GetLightRange(light)
	if (light ~= 0) then
		return (ReadProcessMemory(light + 0x1, 1) * 8 / 255)
	end
end

function Light.SetLightPos(light, x, y, z)
	if (light ~= 0) then
		WriteProcessMemory(light + 0x4, x * 16384, 4)
		WriteProcessMemory(light + 0x8, y * 16384, 4)
		WriteProcessMemory(light + 0xC, z * 16384, 4)
	end
end

function Light.SetLightColor(light, red, green, blue)
	if (light ~= 0) then
		WriteProcessMemory(light + 0x12, red, 1)
		WriteProcessMemory(light + 0x11, green, 1)
		WriteProcessMemory(light + 0x10, blue, 1)
	end
end

function Light.SetLightIntensity(light, intensity)
	if (light ~= 0) then
		WriteProcessMemory(light, intensity, 1)	
		--WriteProcessMemory(light + 0x18, intensity, 1) -- basic command change this address but in game no effect	
	end
end

function Light.SetLightRange(light, range)
	if (light ~= 0) then
		WriteProcessMemory(light + 0x1, math.ceil(range * 255 / 8), 1) 
	end
end

function Light.SetLightTime(light, time_on, time_off, time_random)
	if (light ~= 0) then
		WriteProcessMemory(light + 0x14, time_on, 1)
		WriteProcessMemory(light + 0x15, time_off, 1)
		WriteProcessMemory(light + 0x16, time_random, 1)
	end
end
]]--

return Light