-- Object methods
-- Since: v0.4.2
local Obj = {VALID_OBJ_MODEL = {}, OBJ_NAME = {}}

Obj.VALID_OBJ_MODEL = {
1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,
64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,
88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,
112,113,114,116,117,118,119,120,121,122,123,124,125,126,128,129,130,131,138,141,144,145,146,147,
148,149,151,152,155,157,158,163,164,174,175,192,194,197,198,200,201,202,
203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,
227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,247,248,249,250,253,254,255,
256,257,258,259,265,266,277,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295
}

Obj.OBJ_NAME = {
[65535] = "Unknown",
[0] = "Not defined",
[1] = "Bin Lid",
[2] = "Bollard",
[3] = "Cone",
[4] = "Boxes",
[5] = "Blaster",
[6] = "Rubbish",
[7] = "Bin",
[8] = "Animating Oil",
[9] = "Oil",
[10] = "Mine",
[11] = "Bush",
[12] = "Crate",
[13] = "Footy",
[14] = "Hardbox",
[15] = "Newsdis",
[16] = "Oildrum",
[17] = "Tyre",
[18] = "Hydrant Lid",
[19] = "Hydrant",
[20] = "Hydrant Unlid",
[21] = "Roadblock",
[22] = "Bench",
[23] = "Package",
[25] = "Tower", -- Crash game
[42] = "Explode Medium", -- Crash game
[64] = "Moving Pistol",
[65] = "Moving Machingun",
[66] = "Moving Rocketlauncher",
[67] = "Moving Electrogun",
[68] = "Moving Molotov",
[69] = "Moving Greande",
[70] = "Moving Shotgun",
[71] = "Moving ElectroBaton",
[72] = "Moving Flmethrower",
[73] = "Moving Smachingun",
[74] = "Moving Dualpistol",
[75] = "Moving Reserve yellow L",
[76] = "Moving Reserve yellow M",
[77] = "Moving Reserve yellow N",
[78] = "Moving Reserve yellow O",
[79] = "Moving Bomb",
[80] = "Moving Car Oil",
[81] = "Moving Car Mine",
[82] = "Moving Car Machingun",
[83] = "Moving Reserve blue E",
[84] = "Moving Reserve blue F",
[85] = "Moving Reserve blue G",
[86] = "Moving Reserve blue H",
[87] = "Moving Reserve blue I",
[88] = "Moving Reserve blue J",
[89] = "Moving Reserve blue K",
[90] = "Moving Reserve blue L",
[91] = "Moving Reserve blue M",
[92] = "Moving Multiplayer",
[93] = "Moving Life",
[94] = "Moving Health",
[95] = "Moving Armour",
[96] = "Moving Key",
[97] = "Moving Copbribe",
[98] = "Moving Invulnerabillity",
[99] = "Moving Doubledamage",
[100] = "Moving Fastreload",
[101] = "Moving Electrofingers",
[102] = "Moving Respect",
[103] = "Moving Invisibillity",
[104] = "Moving Instantgang",
[105] = "Moving Reserve red N",
[106] = "Moving Reserve red O",
[107] = "Moving Reserve red P",
[108] = "Moving Reserve red Q",
[109] = "Small Arrow",
[110] = "Invisible Object",
[111] = "Blood Spark",
[112] = "Point",
[113] = "Particle System",
[114] = "Firejet", -- Fire engine top
[116] = "Small Brown Skid",
[117] = "Small Grey Skid",
[118] = "Small Red Skid",
[119] = "Medium Brown Skid",
[120] = "Medium Grey Skid",
[121] = "Medium Red Skid",
[122] = "Car Crossing",
[123] = "Car Stop",
[124] = "Big White Skid",
[125] = "Medium White Skid",
[126] = "Small White Skid",
[128] = "Rocket",
[129] = "Bus Stop Marker",
[130] = "Car Shop",
[131] = "Busy Car Shop",
[138] = "Molotov Moving",
[141] = "Invisible Destroyer",
[144] = "Huge Red Skid",
[145] = "Huge White Skid",
[146] = "Huge Brown Skid",
[147] = "Huge Grey Skid",
[148] = "Tanktop",
[149] = "Antenna",
[151] = "Animating Rubbish",
[152] = "Dead Rubbish",
[155] = "Moving Cone",
[157] = "Moving Bin",
[158] = "Moving Bin Lid",
[163] = "Phone",
[164] = "Phone Ringing",
[174] = "Phone Dead",
[175] = "Briefcase",
[176] = "Red Phone", -- Work only if placing gang at 88, 88
[177] = "Red Phone Ringing",
[178] = "Yellow Phone", -- Work only if placing gang at 93.5, 90
[179] = "Yellow Phone Ringing",
[180] = "Green Phone", -- Work only if placing gang at 92.7, 90
[181] = "Green Phone Ringing",
[192] = "Shot",
[194] = "Flaming Bullet", -- No visible
[197] = "Fire",
[198] = "Water Bullet", -- No visible
[200] = "Pistol",
[201] = "Machingun",
[202] = "Rocketlauncher",
[203] = "Electrogun",
[204] = "Molotov",
[205] = "Grenade",
[206] = "Shotgun",
[207] = "ElectroBaton",
[208] = "Flamethrower",
[209] = "Smachingun",
[210] = "Dualpistol",
[211] = "Reserve yellow L",
[212] = "Reserve yellow M",
[213] = "Reserve yellow N",
[214] = "Reserve yellow O",
[215] = "Car Bomb",
[216] = "Car Oil",
[217] = "Car Mine",
[218] = "Car Machingun",
[219] = "Car Tankgun",
[220] = "Car Watergun",
[221] = "Car Flamethrowergun",
[222] = "Car Jeepgun",
[223] = "Car Instantbomb",
[224] = "Collect 24",
[225] = "Collect 25",
[226] = "Collect 26",
[227] = "Collect 27",
[228] = "Multiplayer",
[229] = "Life",
[230] = "Health",
[231] = "Armour", 
[232] = "Key",
[233] = "Police Bribe",
[234] = "Invulnerabillity",
[235] = "Doubledamage",
[236] = "Fastreload",
[237] = "Electrofingers",
[238] = "Respect",
[239] = "Invisible",
[240] = "Instantgang",
[241] = "Reserve red N",
[242] = "Reserve red O",
[243] = "Reserve red P",
[244] = "Reserve red Q",
[247] = "Bomb",
[248] = "Mguntop",
[249] = "Big Brown Skid",
[250] = "Big Grey Skid",
[253] = "Big Red Skid",
[254] = "Bullet",
[255] = "Traffic Light",
[256] = "Red Footprints",
[257] = "Blood",
[258] = "Crossing",
[259] = "Spark",
[265] = "Pistol Bullet",
[266] = "Bonus Token",
[277] = "Taser Bullet",
[279] = "Sound Instant",
[280] = "Invisible Target",
[281] = "Powergen",
[282] = "Powergen Dead",
[283] = "Invisible Destructible",
[284] = "Genlite",
[285] = "Invisible Dead",
[286] = "Kill Frenzy",
[287] = "Loonie Logo",
[288] = "Yakuza Logo",
[289] = "Zaibatsu Logo",
[290] = "Redneck Logo",
[291] = "Scientist Logo",
[292] = "Krishna Logo",
[293] = "Russian Logo",
[294] = "Tunnel Blocker",
[295] = "Remote"
}

--[[
function Obj.GetObjPos(obj)
	local x = 0
	local y = 0
	local z = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		x = ReadProcessMemory(obj_sprite_ptr + 0x14, 4) / 16384
		y = ReadProcessMemory(obj_sprite_ptr + 0x18, 4) / 16384
		z = ReadProcessMemory(obj_sprite_ptr + 0x1C, 4) / 16384
	end
	return x, y, z
end

function Obj.GetObjAngle(obj)
	local rotation = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		rotation = 360 * ReadProcessMemory(obj_sprite_ptr, 4) / 1439;
	end
	return rotation
end

function Obj.GetObjModel(obj)
	local obj_model = 0
	if (model >= 0 and model <= 65535) then
		if (obj ~= nil) then
			obj_model = ReadProcessMemory(obj + 0x18, 2)
		end
	end
	return obj_model
end

function Obj.SetObjAngle(obj, angle)
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		WriteProcessMemory(obj_sprite_ptr, angle * 1439 / 360, 4)
	end
end

-- Work only z need obj sprite pointer?
function Obj.SetObjPos(obj, x, y, z)
	if (x >= 0 and x <= 255 and y >= 0 and y < 255 and z >= 0 and z <= 255) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x14, x * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x18, y * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x1C, z * 16384, 4)
		end
	end
end
]]--

function Obj.GetNameFromModel(model)
	for obj_model,obj_name in pairs(Obj.OBJ_NAME) do
		if (obj_model == model) then
			return obj_name
		end
	end
	return Car.CAR_NAME[65535]
end

function Obj.GetModelFromName(name)
	for obj_model,obj_name in pairs(Obj.OBJ_NAME) do
		if (obj_name == name) then
			return obj_model
		end
	end
	return 65535
end

function Obj.GetObjName(obj)
	if (obj ~= 0) then
		local model = GetObjModel(obj)
		for obj_model,obj_name in pairs(Obj.OBJ_NAME) do
			if (obj_model == model) then
				return obj_name
			end
		end
	end
	return OBJ_NAME[65535]
end

function Obj.IsValidModel(model)
	for i = 1, #Obj.VALID_OBJ_MODEL do
		if (Obj.VALID_OBJ_MODEL[i] == model) then
			return true
		end
	end
	return false
end

function Obj.GetObjSpriteID(obj)
	local obj_spriteid = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		obj_spriteid = ReadProcessMemory(obj_sprite_ptr + 0x22, 2)
	end
	return obj_spriteid
end

function Obj.SetObjSpriteID(obj, spriteid)
	if (spriteid >= 0 and spriteid <= 65535) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x22, spriteid, 2) -- sprite id?
		end
	end
end

return Obj