-- Sound methods
-- Since: v0.4.1
local Sound = {}

--[[
function Sound.GetSoundPos(sound)
	local x = 0
	local y = 0
	local z = 0
	if (sound ~= 0) then
		local sound_ptr = ReadProcessMemory(sound + 0x4, 4)
		x = ReadProcessMemory(sound_ptr + 0x14, 4) / 16384
		y = ReadProcessMemory(sound_ptr + 0x18, 4) / 16384
		z = ReadProcessMemory(sound_ptr + 0x1C, 4) / 16384
	end
	return x, y, z
end

function Sound.SetSoundPos(sound, x, y, z)
	if (x >= 0 and x <= 255 and y >= 0 and y < 255 and z >= 0 and z <= 255) then
		if (sound ~= 0 and sound ~= nil) then
			local obj_sprite_ptr = ReadProcessMemory(sound + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x14, x * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x18, y * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x1C, z * 16384, 4)
		end
	end
end

function Sound.GetSoundID(sound)
	local soundid = 0
	if (sound ~= 0) then
		soundid = ReadProcessMemory(sound + 0x26, 1)
	end
	return soundid
end

function Sound.SetSoundID(sound, id)
	if (sound ~= 0) then
		if (id >= 0 and id <= 255) then
			WriteProcessMemory(sound + 0x26, id, 1)
		end
	end
end

function Sound.GetSoundMode(sound)
	local mode = 0
	if (sound ~= 0) then
		mode = ReadProcessMemory(sound + 0x27, 1)
	end
	return mode
end

function Sound.SetSoundMode(sound, mode)
	if (sound ~= 0) then
		if (mode >= 0 and mode <= 2) then
			WriteProcessMemory(sound + 0x27, mode, 1)
		end
	end
end
]]--

return Sound