#pragma once

#define GAME_VER_11_44 "v11.44"
#define GAME_VER_9_6 "v9.6"
#define GAME_VER_10_3 "v10.3"

#define GAME_OFFSET_VER_11_44 0x3F0000
#define GAME_OFFSET_VER_9_6 0x400000
#define GAME_OFFSET_VER_10_3 0x400000

#define GAME_SIZE_VER_11_44 1740800
#define GAME_SIZE_VER_9_6 -1
#define GAME_SIZE_VER_10_3 2947072

#define PLAYER_OFFSET 0x5EB4FC
#define PED_OFFSET 0x5D85C0

#define MESSAGE_SOUND_ADDRESS 0x5E202C // set 1 to 62
#define FRAME_ADDRESS 0x5E8108
#define NETWORK_ADDRESS 0x673E2C
#define FRAG_LIMIT 0x5EC4AC // +2 bytes
#define PLAYER_KILL 0x5EC4BA // +2 bytes
#define PLAYER_FRAG 0x5EC500 // +2 bytes
#define PLAYER_NAME 0x5EC524 // +32 bytes

#define GMP_NAME_ADRESS 0x5EC070
#define STY_NAME_ADRESS 0x5EC170
#define SCR_NAME_ADRESS 0x5EC270
#define MMP_NAME_ADRESS 0x673E30
#define MMP_NAME_ADRESS_2 0x676DDC 
#define GXT_NAME_ADRESS 0x676CD8
#define PED_ADRESS 0x5D86C0
#define SHOW_PED_CAR_ID 0x5EADA1
#define SHOW_BLOOD 0x5EAD51
#define SHOW_OBJ_ID 0x5EAD52

#define POLICE_SKIP 0x5EAD5E
#define FIREMAN_SKIP 0x5EAD6B
#define MEDIC_SKIP 0x5EAD8B

#define PED_STRUCT_SIZE 0x294
#define CAR_STRUCT_SIZE 0xBC

#define OBJECT_OFFSET (GAME_OFFSET_VER_11_44 + 0x1E8750)
#define SAVEDGAME_OBJECT_OFFSET (GAME_OFFSET_VER_11_44 + 0x275784)
#define SAVEDGAME_OBJECT_POINTER (GAME_OFFSET_VER_11_44 + 0x275788) // = ptr + c = ptr + 2c = first object
#define CAR_STRUCT_POINTER (GAME_OFFSET_VER_11_44 + 0x1F4CA0) // +4 car
#define CAR_ID_POINTER (GAME_OFFSET_VER_11_44 + 0x1EE604)
#define PARCKED_CAR_POINTER (GAME_OFFSET_VER_11_44 + 0x1E86D0) // +14
#define PARCKED_CAR_STRUCT_POINTER (GAME_OFFSET_VER_11_44 + 0x1E86C0) // +0x50 for pos x
#define PLAYER_1_POINTER (GAME_OFFSET_VER_11_44 + 0x1E3CC4)
#define SCR_OFFSET (GAME_OFFSET_VER_11_44 + 0x2744BC)
#define PED_DENSITY (GAME_OFFSET_VER_11_44 + 0x1F5BC0)
#define RIOT_MODE (GAME_OFFSET_VER_11_44 + 0x1F5BC0) // +0x7

#define MAX_CAR_DAMAGE (127)
#define MAX_PED_ID (99)
#define MAX_CAR_ID (200)
#define MAX_PLAYER_NAME (32)