-- GTA2 Object info
-- Revision: v0.1, 16 apr 2018 by DenLover

-- Limits:
MIN_OBJ_MODEL = 1
MAX_OBJ_MODEL = 295

-- Position:
FIND_GROUND_Z = 65535

-- Car shop type (use as model in method CreateObj_):
SHOP_MACHINEGUN = 250
SHOP_OIL = 251
SHOP_MINE = 252
SHOP_BOMB = 254

-- Models:
OBJ_MODEL_INVALID = 65535
OBJ_MODEL_BIN_LID = 1
OBJ_MODEL_BOLLARD = 2
OBJ_MODEL_BLASTER = 5
OBJ_MODEL_CONE = 3
OBJ_MODEL_BOXES = 4
OBJ_MODEL_RUBBISH = 6
OBJ_MODEL_BIN = 7
OBJ_MODEL_ANIMATING_OIL = 8
OBJ_MODEL_OIL = 9
OBJ_MODEL_MINE = 10
OBJ_MODEL_BUSH = 11
OBJ_MODEL_CRATE = 12
OBJ_MODEL_FOOTY = 13
OBJ_MODEL_HARDBOX = 14
OBJ_MODEL_NEWSDIS = 15
OBJ_MODEL_OILDRUM = 16
OBJ_MODEL_TYRE = 17
OBJ_MODEL_HYDRANT = 19
OBJ_MODEL_HYDRANT_LID = 18
OBJ_MODEL_HYDRANT_UNLID = 20
OBJ_MODEL_ROADBLOCK = 21
OBJ_MODEL_BENCH = 22
OBJ_MODEL_PACKAGE = 23
OBJ_MODEL_TOWER = 25
OBJ_MODEL_EXPLODE_MEDIUM = 42
OBJ_MODEL_MOVING_COLLECT_00 = 64 -- PISTOL
OBJ_MODEL_MOVING_COLLECT_01 = 65 -- MACHINGUN
OBJ_MODEL_MOVING_COLLECT_02 = 66 -- ROCKETLAUNCHER
OBJ_MODEL_MOVING_COLLECT_03 = 67 -- ELECTROGUN
OBJ_MODEL_MOVING_COLLECT_04 = 68 -- MOLOTOV
OBJ_MODEL_MOVING_COLLECT_05 = 69 -- GREANDE
OBJ_MODEL_MOVING_COLLECT_06 = 70 -- SHOTGUN
OBJ_MODEL_MOVING_COLLECT_07 = 71 -- BATONSTIK
OBJ_MODEL_MOVING_COLLECT_08 = 72 -- FLMETHROWER
OBJ_MODEL_MOVING_COLLECT_09 = 73 -- SMACHINGUN
OBJ_MODEL_MOVING_COLLECT_10 = 74 -- DUALPISTOL
OBJ_MODEL_MOVING_COLLECT_11 = 75 -- RESERVE_L
OBJ_MODEL_MOVING_COLLECT_12 = 76 -- RESERVE_M
OBJ_MODEL_MOVING_COLLECT_13 = 77 -- RESERVE_N
OBJ_MODEL_MOVING_COLLECT_14 = 78 -- RESERVE_O
OBJ_MODEL_MOVING_COLLECT_15 = 79 -- BOMB
OBJ_MODEL_MOVING_COLLECT_16 = 80 -- CAR_OIL
OBJ_MODEL_MOVING_COLLECT_17 = 81 -- CAR_MINE
OBJ_MODEL_MOVING_COLLECT_18 = 82 -- CAR_MACHINGUN
OBJ_MODEL_MOVING_COLLECT_19 = 83 -- RESERVE_E
OBJ_MODEL_MOVING_COLLECT_20 = 84 -- RESERVE_F
OBJ_MODEL_MOVING_COLLECT_21 = 85 -- RESERVE_G
OBJ_MODEL_MOVING_COLLECT_22 = 86 -- RESERVE_H
OBJ_MODEL_MOVING_COLLECT_23 = 87 -- RESERVE_I
OBJ_MODEL_MOVING_COLLECT_24 = 88 -- RESERVE_J
OBJ_MODEL_MOVING_COLLECT_25 = 89 -- RESERVE_K
OBJ_MODEL_MOVING_COLLECT_26 = 90 -- RESERVE_L
OBJ_MODEL_MOVING_COLLECT_27 = 91 -- RESERVE_M
OBJ_MODEL_MOVING_COLLECT_28 = 92 -- MULTIPLAYER
OBJ_MODEL_MOVING_COLLECT_29 = 93 -- LIFE
OBJ_MODEL_MOVING_COLLECT_30 = 94 -- HEALTH
OBJ_MODEL_MOVING_COLLECT_31 = 95 -- ARMOUR
OBJ_MODEL_MOVING_COLLECT_32 = 96 -- KEY
OBJ_MODEL_MOVING_COLLECT_33 = 97 -- COPBRIBE
OBJ_MODEL_MOVING_COLLECT_34 = 98 -- INVULNERABILLITY
OBJ_MODEL_MOVING_COLLECT_35 = 99 -- DOUBLEDAMAGE
OBJ_MODEL_MOVING_COLLECT_36 = 100 -- FASTRELOAD
OBJ_MODEL_MOVING_COLLECT_37 = 101 -- ELECTROFINGERS
OBJ_MODEL_MOVING_COLLECT_38 = 102 -- RESPECT
OBJ_MODEL_MOVING_COLLECT_39 = 103 -- INVISIBILLITY
OBJ_MODEL_MOVING_COLLECT_40 = 104 -- INSTANTGANG
OBJ_MODEL_MOVING_COLLECT_41 = 105 -- RESERVE_N
OBJ_MODEL_MOVING_COLLECT_42 = 106 -- RESERVE_O
OBJ_MODEL_MOVING_COLLECT_43 = 107 -- RESERVE_P
OBJ_MODEL_MOVING_COLLECT_44 = 108 -- RESERVE_Q
OBJ_MODEL_SMALL_ARROW = 109
OBJ_MODEL_INVISIBLE_OBJ = 110
OBJ_MODEL_BLOOD_SPARK = 111
OBJ_MODEL_POINT = 112
OBJ_MODEL_PARTICLE_SYSTEM = 113
OBJ_MODEL_FIREJET = 114
OBJ_MODEL_SMALL_BROWN_SKID = 116
OBJ_MODEL_SMALL_GREY_SKID = 117
OBJ_MODEL_SMALL_RED_SKID = 118
OBJ_MODEL_MEDIUM_BROWN_SKID = 119
OBJ_MODEL_MEDIUM_GREY_SKID = 120
OBJ_MODEL_MEDIUM_RED_SKID = 121
OBJ_MODEL_BIG_WHITE_SKID = 124
OBJ_MODEL_MEDIUM_WHITE_SKID = 125
OBJ_MODEL_SMALL_WHITE_SKID = 126
OBJ_MODEL_CAR_CROSSING = 122
OBJ_MODEL_CAR_STOP = 123
OBJ_MODEL_ROCKET = 128
OBJ_MODEL_BUS_STOP_MARKER = 129
OBJ_MODEL_CAR_SHOP = 130
OBJ_MODEL_BUSY_CAR_SHOP = 131
OBJ_MODEL_MOLOTOV_MOVING = 138
OBJ_MODEL_INVISIBLE_DESTROYER = 141
OBJ_MODEL_HUGE_RED_SKID = 144
OBJ_MODEL_HUGE_WHITE_SKID = 145
OBJ_MODEL_HUGE_BROWN_SKID = 146
OBJ_MODEL_HUGE_GREY_SKID = 147
OBJ_MODEL_TANKTOP = 148
OBJ_MODEL_ANTENNA = 149
OBJ_MODEL_ANIMATING_RUBBISH = 151
OBJ_MODEL_DEAD_RUBBISH = 152
OBJ_MODEL_MOVING_CONE = 155
OBJ_MODEL_MOVING_BIN = 157
OBJ_MODEL_MOVING_BIN_LID = 158
OBJ_MODEL_PHONE = 163
OBJ_MODEL_PHONE_RINGING = 164
OBJ_MODEL_PHONE_DEAD = 174
OBJ_MODEL_BRIEFCASE = 175
OBJ_MODEL_RED_PHONE = 176
OBJ_MODEL_RED_PHONE_RINGING = 177
OBJ_MODEL_YELLOW_PHONE = 178
OBJ_MODEL_YELLOW_PHONE_RINGING = 179
OBJ_MODEL_GREEN_PHONE = 180
OBJ_MODEL_GREEN_PHONE_RINGING = 181
OBJ_MODEL_SHOT = 192
OBJ_MODEL_FLAMING_BULLET = 194
OBJ_MODEL_FIRE = 197
OBJ_MODEL_WATER_BULLET = 198
OBJ_MODEL_COLLECT_00 = 200 -- PISTOL
OBJ_MODEL_COLLECT_01 = 201 -- MACHINGUN
OBJ_MODEL_COLLECT_02 = 202 -- ROCKETLAUNCHER
OBJ_MODEL_COLLECT_03 = 203 -- ELECTROGUN
OBJ_MODEL_COLLECT_04 = 204 -- MOLOTOV
OBJ_MODEL_COLLECT_05 = 205 -- GRENADE
OBJ_MODEL_COLLECT_06 = 206 -- SHOTGUN
OBJ_MODEL_COLLECT_07 = 207
OBJ_MODEL_COLLECT_08 = 208 -- FLAMETHROWER
OBJ_MODEL_COLLECT_09 = 209 -- SMACHINGUN
OBJ_MODEL_COLLECT_10 = 210 -- DUALPISTOL
OBJ_MODEL_COLLECT_11 = 211
OBJ_MODEL_COLLECT_12 = 212
OBJ_MODEL_COLLECT_13 = 213
OBJ_MODEL_COLLECT_14 = 214
OBJ_MODEL_COLLECT_15 = 215 -- CAR_BOMB
OBJ_MODEL_COLLECT_16 = 216 -- CAR_OIL
OBJ_MODEL_COLLECT_17 = 217 -- CAR_MINE
OBJ_MODEL_COLLECT_18 = 218 -- CAR_MACHINGUN
OBJ_MODEL_COLLECT_19 = 219 -- CAR_TANKGUN (no visible)
OBJ_MODEL_COLLECT_20 = 220 -- CAR_WATERGUN (no visible)
OBJ_MODEL_COLLECT_21 = 221 -- CAR_FLAMETHROWERGUN (no visible)
OBJ_MODEL_COLLECT_22 = 222 -- CAR_JEEPGUN (no visible)
OBJ_MODEL_COLLECT_23 = 223 -- CAR_INSTANTBOMB
OBJ_MODEL_COLLECT_24 = 224
OBJ_MODEL_COLLECT_25 = 225
OBJ_MODEL_COLLECT_26 = 226
OBJ_MODEL_COLLECT_27 = 227
OBJ_MODEL_COLLECT_28 = 228 -- MULTIPLAYER
OBJ_MODEL_COLLECT_29 = 229 -- LIFE
OBJ_MODEL_COLLECT_30 = 230 -- HEALTH
OBJ_MODEL_COLLECT_31 = 231 -- ARMOUR
OBJ_MODEL_COLLECT_32 = 232 -- KEY
OBJ_MODEL_COLLECT_33 = 233 -- POLICE BRIBE
OBJ_MODEL_COLLECT_34 = 234 -- INVULNERABILLITY
OBJ_MODEL_COLLECT_35 = 235 -- DOUBLEDAMAGE
OBJ_MODEL_COLLECT_36 = 236 -- FASTRELOAD
OBJ_MODEL_COLLECT_37 = 237 -- ELECTROFINGERS
OBJ_MODEL_COLLECT_38 = 238 -- RESPECT
OBJ_MODEL_COLLECT_39 = 239 -- INVISIBLE
OBJ_MODEL_COLLECT_40 = 240 -- INSTANTGANG
OBJ_MODEL_COLLECT_41 = 241
OBJ_MODEL_COLLECT_42 = 242
OBJ_MODEL_COLLECT_43 = 243
OBJ_MODEL_COLLECT_44 = 244
OBJ_MODEL_BOMB = 247
OBJ_MODEL_BIG_BROWN_SKID = 249
OBJ_MODEL_BIG_GREY_SKID = 250
OBJ_MODEL_BIG_RED_SKID = 253
OBJ_MODEL_BULLET = 254
OBJ_MODEL_TRAFFIC_LIGHT = 255
OBJ_MODEL_BLOOD = 257
OBJ_MODEL_RED_FOOTPRINTS = 256
OBJ_MODEL_CROSSING = 258
OBJ_MODEL_SPARK = 259
OBJ_MODEL_PISTOL_BULLET = 265
OBJ_MODEL_BONUS_TOKEN = 266
OBJ_MODEL_TASER_BULLET = 277
OBJ_MODEL_SOUND_INSTANT = 279
OBJ_MODEL_INVISIBLE_TARGET = 280
OBJ_MODEL_POWERGEN = 281
OBJ_MODEL_POWERGEN_DEAD = 282
OBJ_MODEL_INVISIBLE_DESTRUCTIBLE = 283
OBJ_MODEL_GENLITE = 284
OBJ_MODEL_INVISIBLE_DEAD = 285
OBJ_MODEL_KILL_FRENZY = 286
OBJ_MODEL_LOONIE_LOGO = 287
OBJ_MODEL_YAKUZA_LOGO = 288
OBJ_MODEL_ZAIBATSU_LOGO = 289
OBJ_MODEL_REDNECK_LOGO = 290
OBJ_MODEL_SCIENTIST_LOGO = 291
OBJ_MODEL_KRISHNA_LOGO = 292
OBJ_MODEL_RUSSIAN_LOGO = 293
OBJ_MODEL_TUNNEL_BLOCKER = 294
OBJ_MODEL_REMOTE = 295