-- GTA2 ped info
-- Revision: v0.1, 16 apr 2018 by DenLover

-- Models:
PED_MODEL_FLAT = 0
PED_MODEL_PLAYER = 2

-- Skins:
SKIN_POLICE_BLUE = 0
SKIN_POLICE_GREEN = 1
SKIN_POLICE_RED = 2
SKIN_POLICE_YELLOW = 3
SKIN_ARMY = 4
SKIN_RED_HEAD_REDNECK = 5
SKIN_BLOND_HEAD_REDNECK = 6
SKIN_SCIENTIST = 7
SKIN_ZAIBATSU = 8
SKIN_KRISTNA = 9
SKIN_RUSSIAN = 10
SKIN_LOONIE = 11
SKIN_ELVIS = 12
SKIN_YAKUZA = 13
SKIN_FIREMAN = 14
SKIN_GREEN_SHORTS = 15
SKIN_MEDIC = 16
SKIN_MUGGER = 17
SKIN_BLUE_DUMMY = 18
SKIN_LIGHT_BLUE_DUMMY = 19
SKIN_TSHIRT_SHORTS_DUMMY = 20
SKIN_SHIRT_TROUSERS_DUMMY = 21
SKIN_PRISON = 22
SKIN_HULK1 = 23
SKIN_HULK2 = 24
SKIN_PLAYER = 25
SKIN_NAKED_DUMMY = 26
-- Assorted dummy remaps 27 to 52

-- Weapons:
WPN_PISTOL = 0
WPN_MACHINE_GUN = 1
WPN_ROCKET_LAUNCHER = 2
WPN_ELECTRO_GUN = 3
WPN_MOLOTOV = 4
WPN_GRENADE = 5
WPN_SHOTGUN = 6
WPN_ELECTRO_BATON = 7
WPN_FLAME_THROWER = 8
WPN_SILENCED_MACHINE_GUN = 9
WPN_DUAL_PISTOL = 10
WPN_RESERVE_WEAPON_L = 11
WPN_RESERVE_WEAPON_M = 12
WPN_RESERVE_WEAPON_N = 13
WPN_RESERVE_WEAPON_O = 14
WPN_CAR_BOMB = 15
WPN_CAR_OIL = 16
WPN_CAR_MINE = 17
WPN_CAR_MACHINE_GUN = 18
WPN_TANK_ROCKET_LAUNCHER = 19
WPN_WATER_CANNON = 20
WPN_CAR_FLAMETHROWER = 21
WPN_JEEP_GUN = 22
WPN_CAR_BOMB_INSTANT = 23
WPN_RESERVE_BLUE_J = 24
WPN_RESERVE_BLUE_K = 25
WPN_RESERVE_BLUE_L = 26
WPN_RESERVE_BLUE_M = 27
WPN_MULTIPLIER = 28
WPN_LIFE = 29
WPN_HEALTH = 30
WPN_ARMOR = 31
WPN_KEY = 32
WPN_COP_BRIBE = 33
WPN_INVULNERABILITY = 34
WPN_DOUBLE_DAMAGE = 35
WPN_FAST_RELOAD = 36
WPN_ELECTROFINGERS = 37
WPN_RESPECT = 38
WPN_INVISIBILITY = 39
WPN_INSTANT_GANG = 40

-- Group type:
PED_GROUP_CHAIN = 1
PED_GROUP_MOB = 2

-- Objective type:
NO_OBJ = 0
FLEE_ON_FOOT_TILL_SAFE = 1
FLEE_CHAR_ON_FOOT_TILL_SAFE = 2
FLEE_CHAR_ON_FOOT_ALWAYS = 3
FLEE_CHAR_ANY_MEANS_TILL_SAFE = 4
FLEE_CHAR_ANY_MEANS_ALWAYS = 5
FLEE_CHAR_ALWAYS_ONCE_CAR_STOPPED = 6
GOTO_AREA_ON_FOOT = 12
GOTO_AREA_ANY_MEANS = 13
GOTO_AREA_IN_CAR = 14 
GOTO_CHAR_ON_FOOT = 16
KILL_CHAR_ANY_MEANS = 19
KILL_CHAR_ON_FOOT = 20
KILL_CAR = 21
GUARD_SPOT = 24
GUARD_AREA = 25
WAIT_ON_FOOT = 26
WAIT_IN_CAR = 27
ENTER_CAR_AS_DRIVER = 35 -- and 0x3E32 0
ENTER_CAR_AS_PASSENGER = 35 -- and 0x3E32 1
ENTER_CAR = 35
LEAVE_CAR = 36
ENTER_TRAIN = 37
LEAVE_TRAIN = 38
FOLLOW_CAR_IN_CAR = 55
FOLLOW_CAR_ON_FOOT_WITH_OFFSET = 56
FIRE_AT_OBJECT_FROM_VEHICLE = 57 -- Use only object!
DESTROY_OBJECT = 58
DESTROY_CAR = 59
ENTER_CAR_PASSENGER = 100 -- Custom code

-- Occupation type http://gtamp.com/forum/viewtopic.php?f=4&t=700&start=20#p9464:
PED_OCCUPATION_PLAYER = 0
PED_OCCUPATION_EMPTY = 1
PED_OCCUPATION_DUMMY = 3
PED_OCCUPATION_DRIVER = 5
PED_OCCUPATION_PSYCHO = 14
PED_OCCUPATION_MUGGER = 15
PED_OCCUPATION_CARTHIEF = 16
PED_OCCUPATION_BANK_ROBBER = 17
PED_OCCUPATION_CRIMINAL = 18
PED_OCCUPATION_ELVIS = 22
PED_OCCUPATION_POLICE = 24
PED_OCCUPATION_SWAT = 25
PED_OCCUPATION_FBI = 26
PED_OCCUPATION_ARMY = 27
PED_OCCUPATION_GUARD = 28
PED_OCCUPATION_GUARD_AGAINST_PLAYER = 32
PED_OCCUPATION_CRIMINAL_TYPE1 = 33
PED_OCCUPATION_CRIMINAL_TYPE2 = 34
PED_OCCUPATION_SPECIAL_GROUP_MEMBER = 35
PED_OCCUPATION_TANK_DRIVER = 36
PED_OCCUPATION_FIREMAN = 38
PED_OCCUPATION_ROAD_BLOCK_TANK_MAN = 39
PED_OCCUPATION_DRONE = 41
PED_OCCUPATION_STAND_STILL_BLOKE = 43
PED_OCCUPATION_ELVIS_LEADER = 44
PED_OCCUPATION_REFUGEES = 45
PED_OCCUPATION_ANY_LAW_ENFORCEMENT = 46
PED_OCCUPATION_ANY_EMERGENCY_SERVICE_MAN = 47
PED_OCCUPATION_ANY_GANG_MEMBER = 48
PED_OCCUPATION_ANY_ELVIS = 49
PED_OCCUPATION_NO_OCCUPATION = 51

-- Search type:
SEARCH_NO_THREATS = 0
SEARCH_LINE_OF_SIGHT = 1
SEARCH_AREA = 2
SEARCH_AREA_PLAYER_ONLY = 5
SEARCH_LINE_OF_SIGHT_PLAYER_ONLY = 6

-- Reaction type:
REACTION_NO_REACTION = 0
REACTION_REACT_AS_NORMAL = 2
REACTION_RUN_AWAY = 3

-- Shooting skills:
SHOOTING_SKILL_CRAP_SHOT = 0
SHOOTING_SKILL_NORMAL_SHOT = 1
SHOOTING_SKILL_CRACK_SHOT = 2

-- Bravery skills:
BRAVERY_SKILL_COWARD = 0
BRAVERY_SKILL_AVERAGE = 1
BRAVERY_SKILL_LOONY = 2