-- Sound info
-- Revision: v0.2, 17 apr 2018 by DenLover

-- Play mode:
SOUND_MODE_PLAY_FOREVER = 0
SOUND_MODE_PLAY_INSTANT = 1

-- Sound ids:
SOUND_WIND = 1
SOUND_SKID = 2
SOUND_NIGHT_CLUB = 3
SOUND_BAR = 4
SOUND_GENERATOR_RUMBLE = 5
SOUND_WORKSHOP = 6
SOUND_VAT = 7
SOUND_CHURCH_SINGING = 8
SOUND_TEMPLE_CHANT = 9
SOUND_INDUSTRIAL_HIGHT = 10
SOUND_HUMAN_ABATTOIR = 11
SOUND_FUNNY_FARM = 12
SOUND_BANK_ALARM = 13
SOUND_INDUSTRIAL_LOW = 14
SOUND_PORTA_LOO = 15
SOUND_WATERFALL = 16
SOUND_CRICKETS = 17
SOUND_PRISON = 18
SOUND_PRISON_ALARM = 19
SOUND_GANG_DUMPED = 20
SOUND_SMUG_LAUGH = 21
SOUND_PRISON_YARD = 22
SOUND_PRISON_RIOT = 23
SOUND_GANG_LOCKED_IN_BUS = 24
SOUND_SHOPPING_MALL = 25
SOUND_CLOCK_TOWER = 26
SOUND_YEEHA_BOMB = 27
SOUND_BOWLING_ALLEY = 28
SOUND_CROWD_NOISE = 29
SOUND_FAN_NOISE = 30
SOUND_GENERATOR_LOSE_POWER = 31
SOUND_SCREAM = 32
SOUND_BOMB_TICK = 33
SOUND_BOMB_TICK_SHIT = 34
SOUND_DETECTED_MUMBLE = 35
SOUND_KRISHNA_CHANT = 36
SOUND_CRYING = 37
SOUND_ROCKET_LAUNCH_FAIL_CLICK = 38
SOUND_ROCKET_FAIL_LAUGH = 39
SOUND_POISONED = 40
SOUND_POWER_PLANT = 41
SOUND_MUMBLE = 42
SOUND_JAZZ_CLUB = 43
SOUND_COUNTRY_CLUB = 44
SOUND_PYLON = 45
SOUND_DISGRACELAND = 46
SOUND_BAR_2 = 47
SOUND_STRIP_CLUB = 48
SOUND_TEMPLE_2 = 49
SOUND_GARAGE_OPEN	= 50
SOUND_GARAGE_CLOSE = 51
SOUND_LET_ME_OUT = 52

-- Sound message codes http://gtamp.com/forum/viewtopic.php?f=4&t=700&start=40#p10081
SOUND_MSG_INSANE_STUNT_BONUS = 0x1 -- INSANE STUNT BONUS!
SOUND_MSG_GRAND_THEFT_AUTO = 0x2 -- GRAND THEFT AUTO!
SOUND_MSG_WIPEOUT = 0x3 -- WIPEOUT!
SOUND_MSG_EXPEDITIOUS_EXECUTION = 0x4 -- EXPEDITIOUS EXECUTION!
SOUND_MSG_GENOCIDE = 0x5 -- GENOCIDE!
SOUND_MSG_COP_KILLA = 0x6 -- COP KILLA!
SOUND_MSG_CAR_JACKA = 0x7 -- CAR JACKA!
SOUND_MSG_ELVIS_HAS_LEFT_THE_BUILDING = 0x8 -- ELVIS HAS LEFT THE BUILDING!
SOUND_MSG_ACCURACY_BONUS = 0x9 -- ACCURACY BONUS!
SOUND_MSG_BACK_TO_FRONT_BONUS = 0xA -- BACK-TO-FRONT-BONUS!
SOUND_MSG_MEDICAL_EMERGENCY = 0xB -- MEDICAL EMERGENCY!
SOUND_MSG_KILL_FRENZY = 0xC -- KILL FRENZY!
SOUND_MSG_BUSTED = 0x11 -- BUSTED!
SOUND_MSG_FRENZY_FAILED = 0x12 -- FRENZY FAILED!
SOUND_MSG_FRENZY_PASSED = 0x13 -- FRENZY PASSED!
SOUND_MSG_FRYING_TONIGHT = 0x14 -- FRYING TONIGHT!
SOUND_MSG_JOB_COMPLETE = 0x16 -- [1124] JOB COMPLETE!
SOUND_MSG_JOB_FAILED = 0x17 -- [1125] JOB FAILED!
SOUND_MSG_RESPECT_IS_EVERYTHING = 0x18 -- AND REMEMBER, RESPECT IS EVERYTHING!
SOUND_MSG_SHOCKING = 0x19 -- SHOCKING!
SOUND_MSG_SOMETHINS_COOKIN = 0x1A -- MMM... SOMETHIN'S COOKIN!
SOUND_MSG_TIMES_UP_PAL = 0x1B -- [5015] TIME'S UP, PAL!
SOUND_MSG_TOASTED = 0x1C -- TOASTED!
SOUND_MSG_WASTED = 0x1D -- WASTED!
SOUND_MSG_BOMBARMED = 0x1E -- bombarmed.wav (weird one)
SOUND_MSG_LAUGH6 = 0x1F -- laugh6.wav
SOUND_MSG_LAUGH = 0x20 -- LAUGH (changes each time you play it)
SOUND_MSG_RACE_OVER = 0x21 -- [5501] RACE OVER!
SOUND_MSG_SECOND_LAP = 0x22 -- [5502] SECOND LAP!
SOUND_MSG_FINAL_LAP = 0x23 -- [5503] FINAL LAP!
SOUND_MSG_RACE_ON = 0x24 -- [5504] RACE ON!
SOUND_MSG_MULTIPLIER_X2 = 0x25 -- [5505] HEY! 30 PEOPLE DOWN! MULTIPLIER X2
SOUND_MSG_MULTIPLIER_X3 = 0x26 -- [5506] OOH! 60 PEOPLE DOWN! MULTIPLIER X3
SOUND_MSG_MULTIPLIER_X4 = 0x27 -- [5507] NICE! 90 PEOPLE DOWN! MULTIPLIER X4
SOUND_MSG_MULTIPLIER_X5 = 0x28 -- [5508] GREAT! 120 PEOPLE DOWN! MULTIPLIER X5
SOUND_MSG_MULTIPLIER_X6 = 0x29 -- [5509] OUTSTANDING! 150 PEOPLE DOWN! MULTIPLIER X6
SOUND_MSG_TIME_OUT = 0x2A -- [5510] TIME OUT!
SOUND_MSG_YOUR_TIME_IS_EXTENDED = 0x2B -- [5000] YOUR TIME IS EXTENDED!
SOUND_MSG_TIMES_UP_PAL = 0x2C -- [5015] TIME'S UP, PAL! (duplicate)
SOUND_MSG_DID_THAT_HURT = 0x2D -- [5031] Oh, sorry about that... Did that hurt?
SOUND_MSG_NICE_WORK = 0x2E -- [5032] Nice work!
SOUND_MSG_CHOCTASTIC = 0x2F -- [5050] CHOCTASTIC!
SOUND_MSG_RASPBERRY_RIPPLE = 0x30 -- [5051] RASPBERRY RIPPLE!
SOUND_MSG_YOU_SHOT_YOUR_LOAD = 0x31 -- [5052] YOU SHOT YOUR LOAD!
SOUND_MSG_OHH_DID_THAT_HURT = 0x32 -- [5053] OOH... DID THAT HURT?
SOUND_MSG_DEATH_TO_ICE-CREAM_VANS = 0x33 -- [5054] DEATH TO ICE-CREAM VANS!
SOUND_MSG_CRISPY_CRITTER = 0x34 -- [5055] CRISPY CRITTER!
SOUND_MSG_YOURE_TOAST_BUDDY = 0x35 -- [5056] YOU'RE TOAST, BUDDY!
SOUND_MSG_EAT_LEADEN_DEATH_PUNK = 0x36 -- [5057] EAT LEADEN DEATH, PUNK!
SOUND_MSG_THATS_GOTTA_HURT = 0x37 -- [5058] THAT'S GOTTA HURT!
SOUND_MSG_SORRY_ABOUT_THAT = 0x38 -- [5059] SORRY ABOUT THAT!
SOUND_MSG_XIN_LOI_MY_MAN = 0x39 -- [5060] XIN LOI, MY MAN!
SOUND_MSG_DAMN_SUNDAY_DRIVERS = 0x3A -- [5061] DAMN SUNDAY DRIVERS!
SOUND_MSG_SUCK_IT_AND_SEE = 0x3B -- [5062] SUCK IT AND SEE!
SOUND_MSG_TASTE_MY_WRATH_ICE_CREAM_BOY = 0x3C -- [5063] TASTE MY WRATH, ICE-CREAM BOY!
SOUND_MSG_HALLELUJAH_ANOTHER_SOUL_SAVED = 0x3D -- HALLELUJAH, ANOTHER SOUL SAVED!
SOUND_MSG_DAMNATION_NO_SALVATION = 0x3E -- DAMNATION, NO DONATION, NO SALVATION!